/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.mendelu.savic.vida_cs_snake_client.controller;

import cz.mendelu.savic.vida_cs_snake.controller.GameBoardController;
import cz.mendelu.savic.vida_cs_snake.model.DirectionEnum;
import javafx.scene.Parent;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.SwipeEvent;

/**
 *
 * @author david
 */
public class GameBoardListener {
    private Parent gameBoardRoot;
    private Client client;
    
    public GameBoardListener(Parent gameBoardRoot, Client client) {
        this.client = client;
        setEvents(gameBoardRoot);
    }
    
    private void setEvents(Parent gameBoardRoot) {
        this.gameBoardRoot = gameBoardRoot;
        gameBoardRoot.setOnKeyPressed((KeyEvent event) -> {
            keyPressed(event);
        });
        gameBoardRoot.setOnSwipeUp((SwipeEvent event) -> {
            moveSnakeUp();
        });
        gameBoardRoot.setOnSwipeRight((SwipeEvent event) -> {
            moveSnakeRight();
        });
        gameBoardRoot.setOnSwipeDown((SwipeEvent event) -> {
            moveSnakeDown();
        });
        gameBoardRoot.setOnSwipeLeft((SwipeEvent event) -> {
            moveSnakeLeft();
        });
    }

    public void moveSnakeUp() {
        client.moveSnake(DirectionEnum.UP);
    }

    public void moveSnakeRight() {
        client.moveSnake(DirectionEnum.RIGHT);
    }

    public void moveSnakeDown() {
        client.moveSnake(DirectionEnum.DOWN);
    }

    public void moveSnakeLeft() {
        client.moveSnake(DirectionEnum.LEFT);
    }

    public void keyPressed(KeyEvent ke) {
        switch (ke.getCode()) {
            case UP:
                moveSnakeUp();
                break;
            case RIGHT:
                moveSnakeRight();
                break;
            case DOWN:
                moveSnakeDown();
                break;
            case LEFT:
                moveSnakeLeft();
                break;
        }
    }
}
